Summary: high-performance mail store with imap and pop3
Name: cyrus-imapd
Version: 1.5.10
Release: 1
Copyright: academic/research
Group: Networking/Daemons
URL: http://andrew2.andrew.cmu.edu/cyrus/imapd/
Source0: ftp://ftp.andrew.cmu.edu/pub/cyrus-mail/cyrus-imapd-v1.5.10.tar.gz
Source1: cyrus-README
Packager: B.Candler@pobox.com
Buildroot: /tmp/cyrus-imapd-root

%description
The Cyrus IMAP server is a scaleable enterprise mail system
designed for use from small to large enterprise environments using
standards-based technologies.

A full Cyrus IMAP implementation allows a seamless mail and bulletin
board environment to be set up across multiple servers. It differs from
other IMAP server implementations in that it is run on "sealed"
servers, where users are not normally permitted to log in. The mailbox
database is stored in parts of the filesystem that are private to the
Cyrus IMAP system. All user access to mail is through software using
the IMAP, POP3, or KPOP protocols.

Note that this package can be used by ISPs and other to provide mail
services, but it may not be distributed as part of a commercial product.

%define version %{PACKAGE_VERSION}

%prep
rm -rf $RPM_BUILD_ROOT

%setup -n cyrus-imapd-v%{version}

%build
# I hope one day there is --with-login=pam :-)
./configure --with-tcl=/usr/lib --prefix=/usr --with-login=unix
make

%install
# First create the 'cyrus' user if it doesn't exist
grep ^cyrus: /etc/passwd >/dev/null || {
  echo 'cyrus:*:76:12:cyrus:/var/imap:/bin/bash' >>/etc/passwd
}

cp -p $RPM_SOURCE_DIR/cyrus-README $RPM_BUILD_DIR/cyrus-imapd-v%{version}/README

make install DESTDIR=$RPM_BUILD_ROOT

mkdir $RPM_BUILD_ROOT/etc
cat <<END >$RPM_BUILD_ROOT/etc/imapd.conf
configdirectory: /var/imap
partition-default: /var/spool/imap
admins: root
allowanonymouslogin: no
END

mkdir $RPM_BUILD_ROOT/etc/logrotate.d
cat <<END >$RPM_BUILD_ROOT/etc/logrotate.d/cyrus-imapd
/var/log/imapd.log {
    nocompress
}
END

mkdir $RPM_BUILD_ROOT/etc/cron.daily
cat <<END >$RPM_BUILD_ROOT/etc/cron.daily/cyrus-imapd
#!/bin/bash
su cyrus -s /bin/bash -c '/usr/cyrus/bin/deliver -E 3'
END
chmod +x $RPM_BUILD_ROOT/etc/cron.daily/cyrus-imapd

mkdir $RPM_BUILD_ROOT/var
cd $RPM_BUILD_ROOT/var
mkdir imap
chown cyrus imap
chgrp mail imap
chmod 750 imap

cd imap
true >> mailboxes
mkdir user quota proc log msg
chown cyrus *
chgrp mail *

mkdir $RPM_BUILD_ROOT/var/spool
cd $RPM_BUILD_ROOT/var/spool
mkdir imap
chown cyrus imap
chgrp mail imap
chmod 750 imap

mkdir -p $RPM_BUILD_ROOT/usr/sbin
ln -s ../cyrus/bin/imapd $RPM_BUILD_ROOT/usr/sbin/imapd
ln -s ../cyrus/bin/pop3d $RPM_BUILD_ROOT/usr/sbin/ipop3d

%clean
rm -rf $RPM_BUILD_ROOT

%pre
# create the 'cyrus' user if it doesn't exist
grep ^cyrus: /etc/passwd >/dev/null || {
  echo 'cyrus:*:76:12:cyrus:/var/imap:/bin/bash' >>/etc/passwd
}

%post
# update syslog
grep ^local6 /etc/syslog.conf >/dev/null || {
  echo "local6.debug						/var/log/imapd.log" >>/etc/syslog.conf
  killall -1 syslogd 2>/dev/null
}
touch /var/log/imapd.log
chmod 640 /var/log/imapd.log

# update inetd to run as user 'cyrus'
sed '/^imap/s/root/cyrus/;/^pop-3/s/root/cyrus/' </etc/inetd.conf >/etc/inetd.conf.tmp &&
mv /etc/inetd.conf.tmp /etc/inetd.conf &&
killall -1 inetd 2>/dev/null

# force synchronous updates
cd /var/imap
chattr +S . user quota 2>/dev/null
chattr +S /var/spool/imap 2>/dev/null

%postun
# DON'T remove the 'cyrus' user; if sendmail's config contains
# Mcyrus... U=cyrus:mail, then it will barf without it
#grep ^cyrus: /etc/passwd >/dev/null &&
#grep -v ^cyrus: /etc/passwd >/etc/passwd.tmp &&
#mv /etc/passwd.tmp /etc/passwd

# put the inetd config file back to normal
sed '/^imap/s/cyrus/root/;/^pop-3/s/cyrus/root/' </etc/inetd.conf >/etc/inetd.conf.tmp &&
mv /etc/inetd.conf.tmp /etc/inetd.conf &&
killall -1 inetd 2>/dev/null

%files
%doc README doc
# build roots are your friend - if only they would exclude /usr/doc!
%config /etc/imapd.conf
/etc/logrotate.d
/etc/cron.daily
/usr/bin
/usr/cyrus
/usr/include
/usr/lib
/usr/man
/usr/sbin
/var
